EnTT: entt::allocation_deleter< Allocator > Struct Template Reference

EnTT 3.16.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
entt::allocation_deleter< Allocator > Struct Template Reference

Deleter for allocator-aware unique pointers (waiting for C++20). More...

`#include <memory.hpp>`

Inheritance diagram for entt::allocation_deleter< Allocator >:
[legend]
Collaboration diagram for entt::allocation_deleter< Allocator >:
[legend]

## Public Types
using | allocator_type = Allocator
| Allocator type.
using | pointer = typename std::allocator_traits<Allocator>::pointer
| Pointer type.

## Public Member Functions
constexpr | allocation_deleter (const allocator_type &alloc) noexcept(std::is_nothrow_copy_constructible_v< allocator_type >)
| Inherited constructors.
constexpr void | operator() (pointer ptr) noexcept(std::is_nothrow_destructible_v< typename allocator_type::value_type >)
| Destroys the pointed object and deallocates its memory.

## Detailed Description

template<typename Allocator>
struct entt::allocation_deleter< Allocator >

Deleter for allocator-aware unique pointers (waiting for C++20).

Template Parameters

  Allocator | Type of allocator used to manage memory and elements.

Definition at line 75 of file memory.hpp.

## Member Typedef Documentation

## ◆ allocator_type

template<typename Allocator>

using entt::allocation_deleter< Allocator >::allocator_type = Allocator

Allocator type.

Definition at line 77 of file memory.hpp.

## ◆ pointer

template<typename Allocator>

using entt::allocation_deleter< Allocator >::pointer = typename std::allocator_traits<Allocator>::pointer

Pointer type.

Definition at line 79 of file memory.hpp.

## Constructor & Destructor Documentation

## ◆ allocation_deleter()

template<typename Allocator>

entt::allocation_deleter< Allocator >::allocation_deleter | ( | const allocator_type & | alloc | ) |
| inlineconstexprnoexcept

Inherited constructors.

Parameters

  alloc | The allocator to use.

Definition at line 85 of file memory.hpp.

## Member Function Documentation

## ◆ operator()()

template<typename Allocator>

void entt::allocation_deleter< Allocator >::operator() | ( | pointer | ptr | ) |
| inlineconstexprnoexcept

Destroys the pointed object and deallocates its memory.

Parameters

  ptr | A valid pointer to an object of the given type.

Definition at line 92 of file memory.hpp.

The documentation for this struct was generated from the following file:

- src/entt/core/memory.hpp